/**
*
* CVE-Lite Source code
* (c) 2004 David Henderson & Dave Rowbotham
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* Based on an idea introduced by Rob Conley ( estar ) in COMMON_ADDON
* GPDS Ver 2.0 based on GPDS 1.0 by David Henderson ( dh219 )
* CVE Libray coding by Dave Rowbotham.
* CVE-Lite adapted from CVE Library by D Henderson
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/
#include "cvel.h"


/**
*
*    double COMMON_VESSEL_EX::CalculateMass( VECTOR3 *vec )
*
*    return total mass and a VECTOR3 offset for the payload centre of mass.
*
*/
double COMMON_VESSEL_EX::CalculateMass( VECTOR3 *vec )
{

	UINT i;
	double totalmass;

	vec->x = 0.0;
	vec->y = 0.0;
	vec->z = 0.0;
	
	totalmass = 0.0;
	
	for( i = 0 ; i < MAXPAYLOAD-1 ; i++ ) {
		if( payload[i].attached ) {
			vec->x += payload[i].mesh.MeshPosition().x * payload[i].mass;
			vec->y += payload[i].mesh.MeshPosition().y * payload[i].mass;
			vec->z += payload[i].mesh.MeshPosition().z * payload[i].mass;
			totalmass += payload[i].mass;
		}
	}

	if( totalmass > 0.0001 ) {
		vec->x /= totalmass;
		vec->y /= totalmass;
		vec->z /= totalmass;
	}

	return totalmass;

}
//-----------------------------------------------------------------------------------


/**
*
*    double COMMON_VESSEL_EX::CalculateMass()
*
*    return the payload mass and that's all
*/
double COMMON_VESSEL_EX::CalculateMass()
{
	VECTOR3 v;
	return CalculateMass(&v);
}

