/**
*
* CVE-Lite Source code
* (c) 2004 David Henderson & Dave Rowbotham
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* Based on an idea introduced by Rob Conley ( estar ) in COMMON_ADDON
* GPDS Ver 2.0 based on GPDS 1.0 by David Henderson ( dh219 )
* CVE Libray coding by Dave Rowbotham.
* CVE-Lite adapted from CVE Library by D Henderson
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/
#include "cvel.h"

VESSEL* COMMON_VESSEL_EX::DeployPayload()
{
	return DeployPayload(_V(0.0,0.0,0.0));
}
//-----------------------------------------------------------------------------------


/* Pop the next complete payload/stage combination off the stack */


VESSEL* COMMON_VESSEL_EX::DeployPayload( const VECTOR3 &bias)
{
	
	UINT i,j, k;
	COMMON_VESSEL_EX *v;
	VESSEL *vsl;
	VESSELSTATUS vs;
	OBJHANDLE hload;
	VECTOR3 rvel, rpos;
	PAYLOAD p;
	char gpdsbuf[1024];

	hload = NULL;

	for( i = MAXPAYLOAD-1 ; i > 0 && !payload[i].attached ; i-- )
	{
	}

	if( payload[i].attached ) {

		if( payload[i].parent != -1 ) {
			j = payload[i].parent;
			while( payload[j].parent != -1 && payload[j].parent == j-1 ) {
				j = payload[j].parent;
			}
			if( payload[j].attached ) {
				GetStatus(vs);
				vs.eng_hovr = 0;
				vs.eng_main = 0;
				
				Local2Rel( payload[j].currentposition, vs.rpos );
				if( payloadveloverride_active )
					GlobalRot( payloadveloverride, rvel );	
				else
					GlobalRot( payload[j].velocity, rvel );
				payloadveloverride_active = false;
				vs.rvel += rvel;
				vs.fuel = payload[j].fuel;
			
				payload[j].attached = false;

				/* grr at Orbiter's mesh handling meaning this is redundant for the time being */

/*				double theta;
				VECTOR3 gi, gj, gk;
				VECTOR3 r_tmp;
				VECTOR3 ii,jj,kk;

				theta = payload[j].xrot*PI/180.0;

				ii = _V( 1.0, 0.0, 0.0 );
				jj = _V( 0.0, cos(theta), sin(theta) );
				kk = _V( 0.0, -1.0*sin(theta), cos(theta) );
				GlobalRot( kk, gk );
				GlobalRot( jj, gj );
				GlobalRot( ii, gi );

				r_tmp.x = atan2( gk.y,gk.z );
				r_tmp.y = asin( -1.0 * gk.x / sqrt( gk.x*gk.x + gk.y*gk.y + gk.z*gk.z ) );
				r_tmp.z = atan2( gj.x , gi.x );
				vs.arot = r_tmp;
*/
				
				hload = oapiCreateVessel( payload[j].name, payload[j].classname, vs );

				if( !hload )
					return NULL;

				v = (COMMON_VESSEL_EX*)oapiGetVesselInterface( hload );
				vsl = (VESSEL*) v;
				vsl->SetFuelMass(payload[j].fuel*vsl->GetMaxFuelMass());

				if( payload[j].type == 1 ) {
					sprintf( gpdsbuf, "FUEL %.2f", payload[j].fuel );
					for( k = j+1 ; k <= i && payload[k].attached ; k++ ) {
						payload[k].attached = false;
						p = payload[k] ;
						rpos = p.currentposition - payload[j].currentposition;

						sprintf( gpdsbuf, "%s %s %s %s %.2lf %.2lf %.2lf %.2lf %.2lf %.2lf", ( p.type == 0 ? "PAYLOAD" : "STAGE" ),
							p.name, p.mesh.cMeshName(), p.classname, rpos.x, rpos.y, rpos.z, p.mass, p.xrot, p.fuel);
						
						try {
							SendCentralMessage( (VESSEL*)v, ( p.type == 0 ? "PAYLOAD" : "STAGE" ), gpdsbuf );
						}
						catch( ... ) {
							return NULL;
						}

						if( !payload[k+1].attached || payload[k+1].parent < payload[k].parent ) {
							SendCentralMessage( (VESSEL*)v, "ENDSTAGE", "ENDSTAGE" );
						}


					}
				}
				return v;
			}

		}
		else {
			
			GetStatus(vs);
			vs.eng_hovr = 0;
			vs.eng_main = 0;
			vs.fuel = payload[i].fuel;
			Local2Rel( payload[i].currentposition, vs.rpos );
			if( payloadveloverride_active )
				GlobalRot( payloadveloverride, rvel );	
			else
				GlobalRot( payload[i].velocity, rvel );
			payloadveloverride_active = false;
			vs.rvel += rvel;
			vs.fuel = payload[i].fuel;

			payload[i].attached = false;

				double theta;
				VECTOR3 gi, gj, gk;
				VECTOR3 r_tmp;
				VECTOR3 ii,jj,kk;

				theta = payload[i].xrot*PI/180.0;

				ii = _V( 1.0, 0.0, 0.0 );
				jj = _V( 0.0, cos(theta), sin(theta) );
				kk = _V( 0.0, -1.0*sin(theta), cos(theta) );
				GlobalRot( kk, gk );
				GlobalRot( jj, gj );
				GlobalRot( ii, gi );

				/* calculate arot from first principles */
				r_tmp.x = atan2( gk.y,gk.z );
				r_tmp.y = asin( -1.0 * gk.x / sqrt( gk.x*gk.x + gk.y*gk.y + gk.z*gk.z ) );
				r_tmp.z = atan2( gj.x , gi.x );

					
				vs.arot = r_tmp;
			
			
			hload = oapiCreateVessel( payload[i].name, payload[i].classname, vs );


			if( !hload )
				return NULL;
			
			v = (COMMON_VESSEL_EX*)oapiGetVesselInterface( hload );
			vsl = (VESSEL*) v;
			vsl->SetFuelMass(payload[i].fuel*vsl->GetMaxFuelMass());

			return v;

		}
	}

	return NULL;
}
//-----------------------------------------------------------------------------------

