/**
*
* CVE-Lite Source code
* (c) 2004 David Henderson & Dave Rowbotham
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* Based on an idea introduced by Rob Conley ( estar ) in COMMON_ADDON
* GPDS Ver 2.0 based on GPDS 1.0 by David Henderson ( dh219 )
* CVE Libray coding by Dave Rowbotham.
* CVE-Lite adapted from CVE Library by D Henderson
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/
#include "cvel.h"

/**
*
* void COMMON_VESSEL_EX::Draw()
*
* Paint the stage/payload meshes plus any COMMON_MESHES requested by the developer.
*
*/
void COMMON_VESSEL_EX::Draw()
{
	Draw(_V(0.0,0.0,0.0));	
}
//-----------------------------------------------------------------------------------



void COMMON_VESSEL_EX::Draw( const VECTOR3 &bias)
{
	UINT j;
	COMMON_MESH mesh;
	try
	{

		/* Whack on the payloads */
		
		for( j = 0 ; j < MAXPAYLOAD ; j++ ) {
			if( payload[j].attached ) {
				payload[j].currentposition = payload[j].mesh.MeshPosition() +bias + _payload_bias;
				mesh = payload[j].mesh;
				mesh.MeshPosition( payload[j].mesh.MeshPosition() );
				AddMeshEx( mesh );
			}
		}
		
		/*
		*  we need an iterator to walk through the meshes
		*/	
		std::vector< COMMON_MESH>::iterator i;


		/*
		* loop through the sub stage meshes and add the mesh visuals to
		* the orbiter visual representation
		*
		*/
		for( i=self_mesh_list.begin(); i!=self_mesh_list.end(); i++)
		{
				VECTOR3    mp = (*i).MeshPosition() + bias;
				UINT idx=AddMesh( (*i).MeshHandle() , &mp );
				(*i).MeshIndex(idx);
				SetMeshVisibilityMode( idx, MeshVisibilityPreference() );
		}

	}

	/*
	* We catch any exceptions but we deal with it silently.
	*/
	catch(...)
	{

	}

}
//-----------------------------------------------------------------------------------

/**
*
* void COMMON_VESSEL_EX::ClearMeshesEx() 
*
* not only clear meshes, but also wipe the COMMON_MESH list.
*/
void COMMON_VESSEL_EX::ClearMeshesEx() 
{ 
  try
  {
	ClearMeshes();
	self_mesh_list.clear(); 
  }
  catch(...)
  {
 
  }
}

