/**
*
* CVE-Lite Source code
* (c) 2004 David Henderson & Dave Rowbotham
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* Based on an idea introduced by Rob Conley ( estar ) in COMMON_ADDON
* GPDS Ver 2.0 based on GPDS 1.0 by David Henderson ( dh219 )
* CVE Libray coding by Dave Rowbotham.
* CVE-Lite adapted from CVE Library by D Henderson
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/
#include "cvel.h"

/* Reads strings from LoadState and passes them off to SendMessage */

void COMMON_VESSEL_EX::ParsePayloadString( char *payload_string ) {

	int i;
	char localstring[512];

	strncpy( localstring, payload_string, sizeof( localstring )-1 );

	while( strlen( localstring ) > 0 && isspace(localstring[0]) )
		strcpy( localstring, localstring+1 );

	for( i = 0 ; i < strlen( localstring ) ; i++ ) {
		if( isspace(localstring[i]) )
			localstring[i] = 0;
	}

	if( strlen( localstring ) ) {
		SendMessage(localstring, (void*)payload_string );
	}

}

/* parses the GPDS strings. See http://projectganymede.sf.net/cve-lite/
*  for a guide to using GDPS.
*/

void COMMON_VESSEL_EX::ParseCVELString( char *payload_string )
{

	bool parse;
	UINT i;
	char meshname[128];
	VECTOR3 postn;
	MESHHANDLE hmsh;
	char localstring[512];

	strncpy( localstring, payload_string, sizeof( localstring )-1 );

	for( i = 0 ; i < MAXPAYLOAD && payload[i].attached ; i++ )
	{
	}

	if( i == MAXPAYLOAD )
		return;

	while( isspace( localstring[0] ) && strlen( localstring ) > 0 ) {
		strcpy( localstring, localstring+1 );
	}

	parse = false;

	if( strncmp( localstring, "PAYLOAD ", 8 ) == 0 ) {
		payload[i].type = 0;
		parse = true;
		strcpy( localstring, localstring+8 );
	}
	else if( strncmp( localstring, "STAGE ", 6 ) == 0 ) {
		payload[i].type = 1;
		parse = true;
		strcpy( localstring, localstring+6 );
	}
	else if( strncmp( localstring, "ENDCVE", 6 ) == 0 ) {
		if( currentparent != -1 ) {
			currentparent = payload[currentparent].parent;
		}
	}
	else if( strncmp( localstring, "ENDSTAGE", 8 ) == 0 ) {
		if( currentparent != -1 ) {
			currentparent = payload[currentparent].parent;
		}
	}


	if( parse ) {
	
		sscanf( localstring ,"%s %s %s %lf %lf %lf %lf %lf %lf",
			payload[i].name, meshname, payload[i].classname, &postn.x,
			&postn.y, &postn.z, &payload[i].mass, &payload[i].xrot, &payload[i].fuel );

		payload[i].attached = true;
		payload[i].mesh.MeshName(meshname);
		hmsh = oapiLoadMesh (meshname);
		payload[i].mesh.MeshHandle(hmsh);
		payload[i].mesh.MeshPosition(postn);
		payload[i].mesh.MeshPayload(true);
		payload[i].parent = currentparent;

		VECTOR3 pos, vel;
		pos = postn;
		if( mod(pos) > 0.01 ) {
			pos.x /= mod(pos);
			pos.y /= mod(pos);
			pos.z /= mod(pos);
			if( fabs(pos.z) > 0.99 ) {
				vel = _V( 0, 0, 0.5 );
			}
			else {
				pos.z = 0.0;
				pos.x /= mod(pos) * 0.5;
				pos.y /= mod(pos) * 0.5;
				vel = pos;
			}
		}
		else
			vel = _V(0,0,0.5);
		payload[i].velocity = vel;

		if( payload[i].type == 1 ) {
			currentparent = i;
		}

	}

}
//-----------------------------------------------------------------------------------
