/**
*
* CVE-Lite Source code
* (c) 2004 David Henderson & Dave Rowbotham
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* Based on an idea introduced by Rob Conley ( estar ) in COMMON_ADDON
* GPDS Ver 2.0 based on GPDS 1.0 by David Henderson ( dh219 )
* CVE Libray coding by Dave Rowbotham.
* CVE-Lite adapted from CVE Library by D Henderson
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/
#include "cvel.h"

/* SendMessage() receives messages from ParsePayloadString and
/* CheckCentralMessage() and decides if it wants to hand them to
/* ParseCVEString() or ParseCustomCVEString().
/* Users wishing to implment custom CVE inter-vessel communication
/* strings are advised to override ParseCustomPayloadString() to
/* receive the messages.
*/

int COMMON_VESSEL_EX::SendMessage(const char* pszMessage, void* aMessage)
{

	char key[128];
	char message[2048];

	strncpy( key, pszMessage, 127 );
	key[127] = 0;

	strncpy( message, (char*)aMessage, 2047 );
	message[2047] = 0;

 try
 {

	/**
	*   GPDS Specific code
	*/
	if( !strcmp(key, "PAYLOAD" ) ) 
	{
		ParseCVELString( (char*)aMessage);
	}
	else if( !strcmp(key, "STAGE") )
	{
		ParseCVELString( (char*)aMessage);

	}
/*	else if( !strcmp(key, "ADDMESH") )
	{
		ParseCVELString( (char*)aMessage);
	}
*/	else if( !strcmp(key, "ENDCVE") )
	{
		ParseCVELString( (char*)aMessage);
	}
	else if( !strcmp(key, "ENDSTAGE") )
	{
		ParseCVELString( (char*)aMessage);
	}

	/**
	*  Custom 3rd party string handler
	*/
	else
	{
		ParseCustomCVELString( key,  message );
	}

	return 1;
 }
 catch(...)
 {

	return 1;
 }
}
//-----------------------------------------------------------------------------------



