/**
* $Id: cvelmessage.cpp,v 1.2 2004/07/23 10:00:39 dh219 Exp $
*
* CVE-Lite Source code
* (c) 2004 David Henderson & Dave Rowbotham
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* Based on an idea introduced by Rob Conley ( estar ) in COMMON_ADDON
* GPDS Ver 2.0 based on GPDS 1.0 by David Henderson ( dh219 )
* CVE Libray coding by Dave Rowbotham.
* CVE-Lite adapted from CVE Library by D Henderson
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/

#define _LIBRARY
#define MAXMSG 100

#include <ctime>
#include <cstdio>
#include "cvelmessage.h"


void initarray();
int pushmsg( VESSEL *vessel, char *key, char *message );
int popmsg( VESSEL *vessel, char *key, char *message );
void cleanmsg();
void debugmsg(char *);


bool initialised = false;

class MESSAGE {

public:
	MESSAGE( VESSEL *vin, char *kin, char *min );
	~MESSAGE();
	VESSEL *v;
	char key[512];
	char message[2048];
	time_t t;
};

MESSAGE::MESSAGE(VESSEL *vin, char *kin, char *min ){
	v = vin;
	strncpy( key, kin, sizeof( key ) );
	strncpy( message, min, sizeof( message ) );
	t = time(NULL);
}

MESSAGE::~MESSAGE() {
	v = NULL;
	t = 0;
}

MESSAGE *msgs[MAXMSG];


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			initarray();
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

DLLCALLBACK int SendCMessage( VESSEL *vessel , char *key, char *message ) {

//	MessageBox( NULL,message,"SendCMessage rec'd",MB_ICONINFORMATION);	

	int stack;
	stack = pushmsg( vessel, key, message );
	cleanmsg();
	return( stack );
}


DLLCALLBACK int CheckCMessage( VESSEL *vessel , char *key, char *message ) {

	int rc;
	rc = popmsg( vessel, key, message );
	cleanmsg();
	return rc;
}


void initarray() {
	if( initialised )
		return;
	int i;
	for( i = 0 ; i < MAXMSG ; i++ ) {
		msgs[i] = NULL;
	}
	initialised = true;
}

int pushmsg( VESSEL *vessel, char *key, char *message ) {

	int i;
	i = 0;
	while( msgs[i] != NULL && i < MAXMSG )
		i++;

	if( i < MAXMSG ) {
		msgs[i] = new MESSAGE( vessel ,key, message );
//		MessageBox( NULL,message,"pushMessage",MB_ICONINFORMATION);	
		
/*		char tmp[20];
		sprintf( tmp, "new message(%i)", i );
		debugmsg(tmp);
*/
		return i;
	}
	
	return -1;
}

int popmsg( VESSEL *vessel, char *key, char *message ) {

	int i;

	key[0] = 0;
	message[0] = 0;
	for( i = 0 ; i < MAXMSG ; i++ ) {
		if( msgs[i] != NULL  ) {
			if( msgs[i]->v == vessel ) {
				strncpy( key, msgs[i]->key, 255 );
				strncpy( message, msgs[i]->message, 2047 );
//				MessageBox( NULL,msgs[i]->message,"CheckCMessage",MB_ICONINFORMATION);	

				delete msgs[i];
				msgs[i] = NULL;

/*				char tmp[20];
				sprintf( tmp, "returned message(%i)", i );
				debugmsg(tmp);
*/
				return i;
			}
		}
	}
	return -1;
}

void cleanmsg() {

	int i;

	for( i = 0 ; i < MAXMSG ; i++ ) {
		if( msgs[i] != NULL  ) {
			if( msgs[i]->t < time(NULL) - 30 ) {
				delete msgs[i];
				msgs[i] = NULL;
			}
		}
	}

}

void debugmsg(char *in) {
	MessageBox( NULL,in,"cvelmessage.dll",MB_ICONINFORMATION);	
}
